#ifndef _LIB_ERROR_H
#define _LIB_ERROR_H

void xerror();

enum {	EESUCCESS, EEUNKNOWN,
	EEOPEN, EECLOSE,
	EEREAD, EEWRITE,
	EESEEK, EETRUNC,
	EENOMEM,
	EEMKDIR, EEOPENDIR, EECHDIR,
	EESTAT,
	EEWRONGOPT,
	EEINTERNAL};

extern char * errors[];

struct g_error_t {
	char desc[4097];
	char msg[4097];
	int  type;
	int is_set;
};

struct g_error_t g_error;

void qerror(int errortype, char const * desc);
void qerror2(int errortype, char const * desc, char const * desc2);
void qerror_m(int errortype, char const * desc, char const * msg);
void qerror_c(void);
void qerror_i(char const * desc);

#endif
