#define hash_collisions(ctx) (*(struct hash_hb_t *)ctx.ha[1])

#define HASH_MAX_I ((1024-64)/(2*sizeof(off_t)))
// this fails if off_t is more than 256 bit

struct hash_ha_t {
	uint32_t i[256];
	uint32_t f;
};

struct hash_hb_t {
	off_t w1[HASH_MAX_I];
	off_t w2[HASH_MAX_I];
	uint8_t h[64];
	uint32_t f;
};

struct hash_ctx {
	struct hash_ha_t ha[2];
	int han;
	int hac;
	int hacd;
	int ha0d;
	int f;
};

int hash_init(struct hash_ctx * ctx, char * file);
int hash_insert(struct hash_ctx * ctx, off_t what1, off_t what2,
                uint8_t * h, int length, int hash);
int hash_close(struct hash_ctx * ctx, char * file);
